(* renvoie true ou false *)
(* regles pour cet exercice *)
let regles = [[`a`;`b`;`c`];[`c`;`b`];[`b`];[`e`;`f`]];;

let print_regles r =
(* affiche les regles sous la forme hyp1 & hyp2 -> csq *)
  let rec print_regle_rec q = match q with
    [] -> print_string "-> ";
    | t::q -> print_char t;
              if q = [] then print_char ` ` else print_string " & ";
	      print_regle_rec q
  in let print_regle r = match r with
    [] -> failwith "Erreur : regle vide"
    | t::q -> print_char ` `;             (* indentation *)
              print_regle_rec q;          (* affiche les hyp. de la regle *)
              print_char t                (* affiche la conclusion *)
  in let rec print_regles_rec r = match r with
    [] -> print_char `\n`
    | t::q -> print_regle t;              (* affiche une regle *)
              print_char `\n`;            (* va a la ligne *)
              print_regles_rec q          (* affiche les regles suivantes *)
  in print_string "Les rgles sont :\n";
     print_regles_rec r;
     flush std_out                        (* assure l'affichage effectif *)
;;

let rec prouve r rtot b =
(* renvoie true si b est dmontrable dans le systme de rgles r *)
match r with
  [] -> false                      (* toutes les regles ont t testes *)
  | t::q -> match t with           (* essaye une regle *)
    [] -> failwith "Erreur : rgle vide"
    | x::q2 -> if x = b then       (* si b est la csq de cette regles *)
         if prouvelist rtot q2 then true (* si on peut prouver ses hyp. *)
           else prouve q rtot b    (* sinon essaye la regle suivante *)
       else prouve q rtot b        (* idem *)
and prouvelist rtot l = match l with
  [] -> true
  | t::q -> if (prouve rtot rtot t) then (prouvelist rtot q)
              else false
;;

print_regles regles;
print_string "Quel but voulez-vous tester ?\n";
flush std_out;
(if prouve regles regles (input_char std_in) then
  print_string "Le but est prouv\n"
else
  print_string "Le but est indmontrable\n")
;;
exit 0;;
